using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.IO;
using System.Diagnostics;

namespace SeqSharp
{
	/// <summary>
	/// t@CύXmFʂłB
	/// </summary>
	public class ConfirmationWindow : System.Windows.Forms.Form
    {
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.TextBox previewBox;
		private System.Windows.Forms.Button yesButton;
		private System.Windows.Forms.Button noButton;
		/// <summary>
		/// KvȃfUCiϐłB
		/// </summary>
		private System.ComponentModel.Container components = null;

        // ύX̃t@CXg
        private ArrayList newFileList = new ArrayList();

        // eEBhE
		private MainWindow mainWindow;

		public ConfirmationWindow(MainWindow parent)
		{
			//
			// Windows tH[ fUCi T|[gɕKvłB
			//
			InitializeComponent();

			mainWindow = parent;
		}

		/// <summary>
		/// gpĂ郊\[XɌ㏈s܂B
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows tH[ fUCiŐꂽR[h 
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(ConfirmationWindow));
            this.label3 = new System.Windows.Forms.Label();
            this.label4 = new System.Windows.Forms.Label();
            this.previewBox = new System.Windows.Forms.TextBox();
            this.yesButton = new System.Windows.Forms.Button();
            this.noButton = new System.Windows.Forms.Button();
            this.SuspendLayout();
            // 
            // label3
            // 
            this.label3.Location = new System.Drawing.Point(14, 19);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(318, 15);
            this.label3.TabIndex = 2;
            this.label3.Text = "Iꂽt@C͈ȉ̂悤ȃt@CɂȂ܂B";
            // 
            // label4
            // 
            this.label4.Location = new System.Drawing.Point(14, 45);
            this.label4.Name = "label4";
            this.label4.Size = new System.Drawing.Size(200, 16);
            this.label4.TabIndex = 3;
            this.label4.Text = "t@CύXĂ낵łH";
            // 
            // previewBox
            // 
            this.previewBox.Location = new System.Drawing.Point(16, 80);
            this.previewBox.Multiline = true;
            this.previewBox.Name = "previewBox";
            this.previewBox.ReadOnly = true;
            this.previewBox.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
            this.previewBox.Size = new System.Drawing.Size(352, 248);
            this.previewBox.TabIndex = 4;
            // 
            // yesButton
            // 
            this.yesButton.Location = new System.Drawing.Point(104, 344);
            this.yesButton.Name = "yesButton";
            this.yesButton.Size = new System.Drawing.Size(75, 23);
            this.yesButton.TabIndex = 5;
            this.yesButton.Text = "͂";
            this.yesButton.Click += new System.EventHandler(this.yesButton_Click);
            // 
            // noButton
            // 
            this.noButton.Location = new System.Drawing.Point(200, 344);
            this.noButton.Name = "noButton";
            this.noButton.Size = new System.Drawing.Size(75, 23);
            this.noButton.TabIndex = 6;
            this.noButton.Text = "";
            this.noButton.Click += new System.EventHandler(this.noButton_Click);
            // 
            // ConfirmationWindow
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 12);
            this.ClientSize = new System.Drawing.Size(384, 384);
            this.Controls.Add(this.noButton);
            this.Controls.Add(this.yesButton);
            this.Controls.Add(this.previewBox);
            this.Controls.Add(this.label4);
            this.Controls.Add(this.label3);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.MaximizeBox = false;
            this.Name = "ConfirmationWindow";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
            this.Text = "Seq#";
            this.Load += new System.EventHandler(this.ConfirmationWindow_Load);
            this.ResumeLayout(false);
            this.PerformLayout();

		}
		#endregion

		/// <summary>
		/// EBhE[h̏łB
		/// </summary>
		/// <param name="sender">Cxg𔭐IuWFNg</param>
		/// <param name="e">Cxg</param>
		private void ConfirmationWindow_Load(object sender, System.EventArgs e)
		{
			// ݂̘A
			int currentNumber = mainWindow.StartNumber;

			// ݂̘AԂ̕\
			string stringNumber = null;

			for(int i = 0; i < mainWindow.FileListBox.SelectedItems.Count; i++)
			{
				stringNumber = currentNumber.ToString();

				int zeroPaddingLength = mainWindow.Figure - stringNumber.Length;

				for(int j = 0; j < zeroPaddingLength; j++)
				{
					stringNumber = "0" + stringNumber;
				}

				// Vt@C
				string newFileName
					= mainWindow.Place + @"\" + mainWindow.Prefix
					+ stringNumber + ((MyFileInfo)mainWindow.FileListBox.SelectedItems[i]).Extension;

				FileInfo newFi = new FileInfo(newFileName);

                // ύX̃t@CXgɕۑ
                newFileList.Add(newFi);

				// t@CύXʂo
				previewBox.AppendText(
                    ((MyFileInfo)mainWindow.FileListBox.SelectedItems[i]).Name + " -> " + newFi.Name + "\r\n");

				currentNumber++;
			}

			yesButton.Select();
		}

		/// <summary>
		/// {^NbNꂽƂ̏łB
		/// </summary>
		/// <param name="sender">Cxg𔭐IuWFNg</param>
		/// <param name="e">Cxg</param>
		private void noButton_Click(object sender, System.EventArgs e)
		{
			Close();
		}

		/// <summary>
		/// ͂{^NbNꂽƂ̏łB
		/// </summary>
		/// <param name="sender">Cxg𔭐IuWFNg</param>
		/// <param name="e">Cxg</param>
		private void yesButton_Click(object sender, System.EventArgs e)
		{
            //
            // ύX̃t@Cׂđ݂邩ǂ`FbN
            //
            foreach (MyFileInfo fi in mainWindow.FileListBox.SelectedItems)
            {
                if (!fi.Exists)
                {
                    // G[bZ[W\
                    MessageBox.Show(
                        "ύX̃t@C(" + fi.Name + ")݂܂B\nt@CύXł܂B",
                        "Seq#",
                        MessageBoxButtons.OK,
                        MessageBoxIcon.Exclamation);

                    return;
                }
            }

            //
            // ׂẴt@CVt@CɕύXł邩ǂ`FbN
            //
            foreach(FileInfo fi in newFileList)
            {
                if (fi.Exists)
                {
                    // G[bZ[W\
                    MessageBox.Show(
                        "ύX̃t@C(" + fi.Name + ")łɑ݂܂B\nt@CύXł܂B",
                        "Seq#",
                        MessageBoxButtons.OK,
                        MessageBoxIcon.Exclamation);

                    return;
                }
            }

            //
			// Iꂽt@CAԕtt@CɕύX
            //
            for (int i = 0; i < mainWindow.FileListBox.SelectedItems.Count; i++)
			{
                try
                {
                    MyFileInfo fi = (MyFileInfo)mainWindow.FileListBox.SelectedItems[i];

                    // t@CύX
                    File.Move(fi.FullName, ((FileInfo)newFileList[i]).FullName);
                }
                catch (IOException ioe)
                {
                    Debug.WriteLine(ioe.StackTrace);

                    // G[bZ[W\
                    MessageBox.Show(
                        "t@C̕ύXɃG[܂BI܂B",
                        "Seq#",
                        MessageBoxButtons.OK,
                        MessageBoxIcon.Exclamation);

                    return;
                }
			}

			MessageBox.Show(
                newFileList.Count.ToString() + "̃t@CύX܂B",
				"Seq#",
				MessageBoxButtons.OK,
				MessageBoxIcon.Information);

            // CEBhẼt@CXg̓eXV
            mainWindow.RefreshFileList();

			Close();
		}
	}
}
